require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_test.dat"
Modshogun::Math.init_random 1

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::MulticlassLabels.new f_labels_train
labels_test = Modshogun::MulticlassLabels.new f_labels_test
#![create_features]

#![create_classifier]
classifier = Modshogun::LibLinear.new 
#![create_classifier]

#![choose_strategy]
encoder = Modshogun::ECOCRandomDenseEncoder.new 
decoder = Modshogun::ECOCHDDecoder.new 
rnd_dense_strategy = Modshogun::ECOCStrategy.new encoder, decoder
#![choose_strategy]

#![create_instance]
mc_classifier = Modshogun::LinearMulticlassMachine.new rnd_dense_strategy, features_train, classifier, labels_train
#![create_instance]

#![train_and_apply]
mc_classifier.train 
labels_predict = mc_classifier.apply_multiclass features_test
#![train_and_apply]

#![evaluate_accuracy]
eval = Modshogun::MulticlassAccuracy.new 
accuracy = eval.evaluate labels_predict, labels_test
#![evaluate_accuracy]

# integration testing variables
output = labels_predict.get_labels 

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "multiclass_ecoc_random.dat", 'w'
__sg_storage.append_wrapped_real accuracy, "accuracy"
__sg_storage.append_wrapped_real_vector output, "output"
__sg_storage.save_serializable __sg_storage_file
